commit 634384276d68f7e906c61fc0ed30eaef17c6e1f8
Author: freddy77 <freddy77>
Date:   Tue Dec 16 09:26:02 2008 +0000

    add and reuse tds_bcp_init

diff --git a/ChangeLog b/ChangeLog
index 61a9f90..8565a4a 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Tue Dec 16 10:25:33 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/ctlib/blk.c src/dblib/bcp.c src/tds/bulk.c:
+	- add and reuse tds_bcp_init
+	- small bulk.c improves
+
 Tue Dec 16 10:19:26 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/util.c src/apps/tsql.c:
 	- remove formatting problems
@@ -1077,4 +1082,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2683 2008/12/16 09:21:08 freddy77 Exp $
+$Id: ChangeLog,v 1.2684 2008/12/16 09:26:02 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 025d154..8f49901 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.307 2008/12/15 15:52:10 freddy77 Exp $ */
+/* $Id: tds.h,v 1.308 2008/12/16 09:26:02 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1612,6 +1612,7 @@ typedef struct tds_bcpinfo
 	TDSRESULTINFO *bindinfo;
 } TDSBCPINFO;
 
+int tds_bcp_init(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 typedef int  (*tds_bcp_get_col_data) (TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
 typedef void (*tds_bcp_null_error)   (TDSBCPINFO *bulk, int index, int offset);
 int tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset);
diff --git a/src/ctlib/blk.c b/src/ctlib/blk.c
index 6849b68..f37732a 100644
--- a/src/ctlib/blk.c
+++ b/src/ctlib/blk.c
@@ -38,7 +38,7 @@
 #include "ctlib.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: blk.c,v 1.47 2008/12/15 15:52:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: blk.c,v 1.48 2008/12/16 09:26:02 freddy77 Exp $");
 
 static void _blk_null_error(TDSBCPINFO *bcpinfo, int index, int offset);
 static int _blk_get_col_data(TDSBCPINFO *bulk, TDSCOLUMN *bcpcol, int offset);
@@ -306,14 +306,6 @@ blk_gettext(SRV_PROC * srvproc, CS_BLKDESC * blkdescp, CS_BLK_ROW * rowp, CS_INT
 CS_RETCODE
 blk_init(CS_BLKDESC * blkdesc, CS_INT direction, CS_CHAR * tablename, CS_INT tnamelen)
 {
-	TDSCOLUMN *curcol;
-
-	TDSSOCKET *tds;
-	TDSRESULTINFO *resinfo;
-	TDSRESULTINFO *bindinfo;
-	TDS_INT result_type;
-	int i, rc;
-
 	tdsdump_log(TDS_DBG_FUNC, "blk_init()\n");
 
 	if (!blkdesc) {
@@ -361,96 +353,12 @@ blk_init(CS_BLKDESC * blkdesc, CS_INT direction, CS_CHAR * tablename, CS_INT tna
 	blkdesc->bcpinfo.xfer_init = 0;
 	blkdesc->bcpinfo.var_cols = 0;
 
-	tds = blkdesc->con->tds_socket;
-
-	/* TODO quote tablename if needed */
-	if (tds_submit_queryf(tds, "select * from %s where 0 = 1", blkdesc->bcpinfo.tablename) == TDS_FAIL) {
+	if (tds_bcp_init(blkdesc->con->tds_socket, &blkdesc->bcpinfo) == TDS_FAIL) {
 		_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
 		return CS_FAIL;
 	}
-
-	while ((rc = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS))
-		   == TDS_SUCCEED) {
-	}
-	if (rc != TDS_NO_MORE_RESULTS) {
-		_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
-		return CS_FAIL;
-	}
-
-	/* copy the results info from the TDS socket into CS_BLKDESC structure */
-
-	if (!tds->res_info) {
-		_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
-		return CS_FAIL;
-	}
-
-	resinfo = tds->res_info;
-
-	if ((bindinfo = tds_alloc_results(resinfo->num_cols)) == NULL) {
-		_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
-		return CS_FAIL;
-	}
-
-
-	bindinfo->row_size = resinfo->row_size;
-
-	for (i = 0; i < bindinfo->num_cols; i++) {
-
-		curcol = bindinfo->columns[i];
-
-		curcol->column_type = resinfo->columns[i]->column_type;
-		curcol->column_usertype = resinfo->columns[i]->column_usertype;
-		curcol->column_flags = resinfo->columns[i]->column_flags;
-		curcol->column_size = resinfo->columns[i]->column_size;
-		curcol->column_varint_size = resinfo->columns[i]->column_varint_size;
-		curcol->column_prec = resinfo->columns[i]->column_prec;
-		curcol->column_scale = resinfo->columns[i]->column_scale;
-		curcol->column_namelen = resinfo->columns[i]->column_namelen;
-		curcol->on_server.column_type = resinfo->columns[i]->on_server.column_type;
-		curcol->on_server.column_size = resinfo->columns[i]->on_server.column_size;
-		curcol->char_conv = resinfo->columns[i]->char_conv;
-		memcpy(curcol->column_name, resinfo->columns[i]->column_name, resinfo->columns[i]->column_namelen);
-		if (curcol->table_column_name)
-			TDS_ZERO_FREE(curcol->table_column_name);
-		if (resinfo->columns[i]->table_column_name)
-			curcol->table_column_name = strdup(resinfo->columns[i]->table_column_name);
-		curcol->column_nullable = resinfo->columns[i]->column_nullable;
-		curcol->column_identity = resinfo->columns[i]->column_identity;
-		curcol->column_timestamp = resinfo->columns[i]->column_timestamp;
-
-		memcpy(curcol->column_collation, resinfo->columns[i]->column_collation, 5);
-
-		if (is_numeric_type(curcol->column_type)) {
-			curcol->bcp_column_data = tds_alloc_bcp_column_data(sizeof(TDS_NUMERIC));
-			((TDS_NUMERIC *) curcol->bcp_column_data->data)->precision = curcol->column_prec;
-			((TDS_NUMERIC *) curcol->bcp_column_data->data)->scale = curcol->column_scale;
-		} else {
-			curcol->bcp_column_data = tds_alloc_bcp_column_data(curcol->on_server.column_size);
-		}
-	}
-
-	/* TODO check */
-	tds_alloc_row(bindinfo);
-
-	blkdesc->bcpinfo.bindinfo = bindinfo;
 	blkdesc->bcpinfo.bind_count = CS_UNUSED;
 
-	if (blkdesc->bcpinfo.identity_insert_on) {
-
-		if (tds_submit_queryf(tds, "set identity_insert %s on", blkdesc->bcpinfo.tablename) == TDS_FAIL) {
-			_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
-			return CS_FAIL;
-		}
-	
-		while ((rc = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS))
-			   == TDS_SUCCEED) {
-		}
-		if (rc != TDS_NO_MORE_RESULTS) {
-			_ctclient_msg(blkdesc->con, "blk_init", 2, 5, 1, 140, "");
-			return CS_FAIL;
-		}
-	}
-
 	return CS_SUCCEED;
 }
 
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index a099b04..0a84483 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -61,7 +61,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.177 2008/12/15 15:52:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.178 2008/12/16 09:26:02 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -89,8 +89,6 @@ static RETCODE _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_
 static int _bcp_readfmt_colinfo(DBPROCESS * dbproc, char *buf, BCP_HOSTCOLINFO * ci);
 static RETCODE _bcp_get_term_var(BYTE * pdata, BYTE * term, int term_len);
 
-static void bcp_row_free(TDSRESULTINFO* result, unsigned char *row);
-
 /** 
  * \ingroup dblib_bcp
  * \brief Prepare for bulk copy operation on a table
@@ -116,12 +114,6 @@ static void bcp_row_free(TDSRESULTINFO* result, unsigned char *row);
 RETCODE
 bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char *errfile, int direction)
 {
-	TDSRESULTINFO *resinfo;
-	TDSRESULTINFO *bindinfo;
-	TDSCOLUMN *curcol;
-	TDS_INT result_type;
-	int i, rc;
-
 	tdsdump_log(TDS_DBG_FUNC, "bcp_init(%p, %s, %s, %s, %d)\n", 
 			dbproc, tblname? tblname:"NULL", hfile? hfile:"NULL", errfile? errfile:"NULL", direction);
 	CHECK_DBPROC();
@@ -189,83 +181,12 @@ bcp_init(DBPROCESS * dbproc, const char *tblname, const char *hfile, const char
 	if (direction == DB_IN) {
 		TDSSOCKET *tds = dbproc->tds_socket;
 
-		if (tds_submit_queryf(tds, "SET FMTONLY ON select * from %s SET FMTONLY OFF", 
-								dbproc->bcpinfo->tablename) == TDS_FAIL) {
+		if (tds_bcp_init(tds, dbproc->bcpinfo) == TDS_FAIL) {
+			/* TODO return proper error */
 			/* Attempt to use Bulk Copy with a non-existent Server table (might be why ...) */
 			dbperror(dbproc, SYBEBCNT, 0);
 			return FAIL;
 		}
-	
-		/* TODO check what happen if table is not present, cleanup on error */
-		while ((rc = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS))
-		       == TDS_SUCCEED) {
-		}
-		if (rc != TDS_NO_MORE_RESULTS) {
-			return FAIL;
-		}
-	
-		if (!tds->res_info) {
-			return FAIL;
-		}
-	
-		/* TODO check what happen if table is not present, cleanup on error */
-		resinfo = tds->res_info;
-		if ((bindinfo = tds_alloc_results(resinfo->num_cols)) == NULL)
-			goto memory_error;
-	
-		bindinfo->row_size = resinfo->row_size;
-	
-		dbproc->bcpinfo->bindinfo = bindinfo;
-		dbproc->bcpinfo->bind_count = 0;
-	
-		/* Copy the column metadata */
-		for (i = 0; i < bindinfo->num_cols; i++) {
-	
-			curcol = bindinfo->columns[i];
-			
-			/*
-			 * TODO use memcpy ??
-			 * curcol and resinfo->columns[i] are both TDSCOLUMN.  
-			 * Why not "curcol = resinfo->columns[i];"?  Because the rest of TDSCOLUMN (below column_timestamp)
-			 * isn't being used.  Perhaps this "upper" part of TDSCOLUMN should be a substructure.
-			 * Or, see if the "lower" part is unused (and zeroed out) at this point, and just do one assignment.
-			 */
-			curcol->column_type = resinfo->columns[i]->column_type;
-			curcol->column_usertype = resinfo->columns[i]->column_usertype;
-			curcol->column_flags = resinfo->columns[i]->column_flags;
-			curcol->column_size = resinfo->columns[i]->column_size;
-			curcol->column_varint_size = resinfo->columns[i]->column_varint_size;
-			curcol->column_prec = resinfo->columns[i]->column_prec;
-			curcol->column_scale = resinfo->columns[i]->column_scale;
-			curcol->column_namelen = resinfo->columns[i]->column_namelen;
-			curcol->on_server.column_type = resinfo->columns[i]->on_server.column_type;
-			curcol->on_server.column_size = resinfo->columns[i]->on_server.column_size;
-			curcol->char_conv = resinfo->columns[i]->char_conv;
-			memcpy(curcol->column_name, resinfo->columns[i]->column_name, resinfo->columns[i]->column_namelen);
-			TDS_ZERO_FREE(curcol->table_column_name);
-			if (resinfo->columns[i]->table_column_name)
-				curcol->table_column_name = strdup(resinfo->columns[i]->table_column_name);
-			curcol->column_nullable = resinfo->columns[i]->column_nullable;
-			curcol->column_identity = resinfo->columns[i]->column_identity;
-			curcol->column_timestamp = resinfo->columns[i]->column_timestamp;
-			
-			memcpy(curcol->column_collation, resinfo->columns[i]->column_collation, 5);
-			
-			if (is_numeric_type(curcol->column_type)) {
-				curcol->bcp_column_data = tds_alloc_bcp_column_data(sizeof(TDS_NUMERIC));
-				((TDS_NUMERIC *) curcol->bcp_column_data->data)->precision = curcol->column_prec;
-				((TDS_NUMERIC *) curcol->bcp_column_data->data)->scale = curcol->column_scale;
-			} else {
-				curcol->bcp_column_data = 
-					tds_alloc_bcp_column_data(MAX(curcol->column_size,curcol->on_server.column_size));
-			}
-		}
-
-		bindinfo->current_row = malloc(bindinfo->row_size);
-		if (!bindinfo->current_row)
-			goto memory_error;
-		bindinfo->row_free = bcp_row_free;
-		return SUCCEED;
 	}
 
 	return SUCCEED;
@@ -1845,13 +1766,6 @@ bcp_exec(DBPROCESS * dbproc, DBINT *rows_copied)
 	return ret;
 }
 
-static void 
-bcp_row_free(TDSRESULTINFO* result, unsigned char *row)
-{
-	result->row_size = 0;
-	TDS_ZERO_FREE(result->current_row);
-}
-
 /** 
  * \ingroup dblib_bcp_internal
  * \brief 
diff --git a/src/tds/bulk.c b/src/tds/bulk.c
index 397d7af..467f736 100644
--- a/src/tds/bulk.c
+++ b/src/tds/bulk.c
@@ -37,12 +37,17 @@
 
 #include "tds.h"
 #include "tds_checks.h"
+#include "tdsbytes.h"
 #include "replacements.h"
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: bulk.c,v 1.4 2008/12/15 15:52:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bulk.c,v 1.5 2008/12/16 09:26:02 freddy77 Exp $");
+
+#ifndef MAX
+#define MAX(a,b) ( (a) > (b) ? (a) : (b) )
+#endif
 
 typedef struct tds_pbcb
 {
@@ -51,21 +56,124 @@ typedef struct tds_pbcb
 	unsigned int from_malloc;
 } TDSPBCB;
 
-static int tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
+static int tds7_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 static int tds_bcp_start_insert_stmt(TDSSOCKET *tds, TDSBCPINFO *bcpinfo);
 static int tds_bcp_add_fixed_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset, unsigned char * rowbuffer, int start);
 static int tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_data, tds_bcp_null_error null_error, int offset, TDS_UCHAR *rowbuffer, int start, int *pncols);
+static void tds_bcp_row_free(TDSRESULTINFO* result, unsigned char *row);
+
+int
+tds_bcp_init(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
+{
+	TDSRESULTINFO *resinfo;
+	TDSRESULTINFO *bindinfo = NULL;
+	TDSCOLUMN *curcol;
+	TDS_INT result_type;
+	int i, rc;
+
+	/* FIXME don't leave state in processing state */
+
+	/* TODO quote tablename if needed */
+	if (tds_submit_queryf(tds, "select * from %s where 0 = 1", bcpinfo->tablename) == TDS_FAIL)
+		/* TODO return an error ?? */
+		/* Attempt to use Bulk Copy with a non-existent Server table (might be why ...) */
+		return TDS_FAIL;
+
+	/* TODO check what happen if table is not present, cleanup on error */
+	while ((rc = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS))
+		   == TDS_SUCCEED) {
+	}
+	if (rc != TDS_NO_MORE_RESULTS)
+		return TDS_FAIL;
+
+	/* copy the results info from the TDS socket */
+	if (!tds->res_info)
+		return TDS_FAIL;
+
+	resinfo = tds->res_info;
+	if ((bindinfo = tds_alloc_results(resinfo->num_cols)) == NULL)
+		goto cleanup;
+
+	bindinfo->row_size = resinfo->row_size;
+
+	/* Copy the column metadata */
+	for (i = 0; i < bindinfo->num_cols; i++) {
+
+		curcol = bindinfo->columns[i];
+		
+		/*
+		 * TODO use memcpy ??
+		 * curcol and resinfo->columns[i] are both TDSCOLUMN.  
+		 * Why not "curcol = resinfo->columns[i];"?  Because the rest of TDSCOLUMN (below column_timestamp)
+		 * isn't being used.  Perhaps this "upper" part of TDSCOLUMN should be a substructure.
+		 * Or, see if the "lower" part is unused (and zeroed out) at this point, and just do one assignment.
+		 */
+		curcol->column_type = resinfo->columns[i]->column_type;
+		curcol->column_usertype = resinfo->columns[i]->column_usertype;
+		curcol->column_flags = resinfo->columns[i]->column_flags;
+		curcol->column_size = resinfo->columns[i]->column_size;
+		curcol->column_varint_size = resinfo->columns[i]->column_varint_size;
+		curcol->column_prec = resinfo->columns[i]->column_prec;
+		curcol->column_scale = resinfo->columns[i]->column_scale;
+		curcol->column_namelen = resinfo->columns[i]->column_namelen;
+		curcol->on_server.column_type = resinfo->columns[i]->on_server.column_type;
+		curcol->on_server.column_size = resinfo->columns[i]->on_server.column_size;
+		curcol->char_conv = resinfo->columns[i]->char_conv;
+		memcpy(curcol->column_name, resinfo->columns[i]->column_name, resinfo->columns[i]->column_namelen);
+		TDS_ZERO_FREE(curcol->table_column_name);
+		if (resinfo->columns[i]->table_column_name)
+			curcol->table_column_name = strdup(resinfo->columns[i]->table_column_name);
+		curcol->column_nullable = resinfo->columns[i]->column_nullable;
+		curcol->column_identity = resinfo->columns[i]->column_identity;
+		curcol->column_timestamp = resinfo->columns[i]->column_timestamp;
+		
+		memcpy(curcol->column_collation, resinfo->columns[i]->column_collation, 5);
+		
+		if (is_numeric_type(curcol->column_type)) {
+			curcol->bcp_column_data = tds_alloc_bcp_column_data(sizeof(TDS_NUMERIC));
+			((TDS_NUMERIC *) curcol->bcp_column_data->data)->precision = curcol->column_prec;
+			((TDS_NUMERIC *) curcol->bcp_column_data->data)->scale = curcol->column_scale;
+		} else {
+			curcol->bcp_column_data = 
+				tds_alloc_bcp_column_data(MAX(curcol->column_size,curcol->on_server.column_size));
+		}
+	}
+
+	bindinfo->current_row = malloc(bindinfo->row_size);
+	if (!bindinfo->current_row)
+		goto cleanup;
+	bindinfo->row_free = tds_bcp_row_free;
+
+	if (bcpinfo->identity_insert_on) {
+
+		if (tds_submit_queryf(tds, "set identity_insert %s on", bcpinfo->tablename) == TDS_FAIL)
+			goto cleanup;
+	
+		while ((rc = tds_process_tokens(tds, &result_type, NULL, TDS_TOKEN_RESULTS))
+			   == TDS_SUCCEED) {
+		}
+		if (rc != TDS_NO_MORE_RESULTS)
+			goto cleanup;
+	}
+
+	bcpinfo->bindinfo = bindinfo;
+	bcpinfo->bind_count = 0;
+	return TDS_SUCCEED;
 
+cleanup:
+	tds_free_results(bindinfo);
+	return TDS_FAIL;
+}
 /** 
  * \return TDS_SUCCEED or TDS_FAIL.
  */
 static int
-tds_build_bulk_insert_stmt(TDSSOCKET * tds, TDSPBCB * clause, TDSCOLUMN * bcpcol, int first)
+tds7_build_bulk_insert_stmt(TDSSOCKET * tds, TDSPBCB * clause, TDSCOLUMN * bcpcol, int first)
 {
 	char buffer[32];
 	char *column_type = buffer;
 
-	tdsdump_log(TDS_DBG_FUNC, "tds_build_bulk_insert_stmt(%p, %p, %p, %d)\n", tds, clause, bcpcol, first);
+	tdsdump_log(TDS_DBG_FUNC, "tds7_build_bulk_insert_stmt(%p, %p, %p, %d)\n", tds, clause, bcpcol, first);
 
 	/* TODO reuse function in tds/query.c */
 	switch (bcpcol->on_server.column_type) {
@@ -246,17 +354,12 @@ tds_bcp_start_insert_stmt(TDSSOCKET * tds, TDSBCPINFO * bcpinfo)
 		for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
 			bcpcol = bcpinfo->bindinfo->columns[i];
 
-			if (bcpinfo->identity_insert_on) {
-				if (!bcpcol->column_timestamp) {
-					tds_build_bulk_insert_stmt(tds, &colclause, bcpcol, firstcol);
-					firstcol = 0;
-				}
-			} else {
-				if (!bcpcol->column_identity && !bcpcol->column_timestamp) {
-					tds_build_bulk_insert_stmt(tds, &colclause, bcpcol, firstcol);
-					firstcol = 0;
-				}
-			}
+			if (bcpcol->column_timestamp)
+				continue;
+			if (!bcpinfo->identity_insert_on && bcpcol->column_identity)
+				continue;
+			tds7_build_bulk_insert_stmt(tds, &colclause, bcpcol, firstcol);
+			firstcol = 0;
 		}
 
 		if (bcpinfo->hint) {
@@ -285,9 +388,7 @@ tds_bcp_start_insert_stmt(TDSSOCKET * tds, TDSBCPINFO * bcpinfo)
 			return TDS_FAIL;
 	}
 
-	tds_submit_query(tds, query);
 	/* save the statement for later... */
-
 	bcpinfo->insert_stmt = query;
 
 	return TDS_SUCCEED;
@@ -312,8 +413,6 @@ tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data ge
 	unsigned char *record;
 	TDS_INT	 old_record_size;
 	TDS_INT	 new_record_size;
-	TDS_INT	     varint_4;
-	TDS_SMALLINT varint_2;
 	TDS_TINYINT  varint_1;
 
 	int row_pos;
@@ -386,18 +485,12 @@ tds_bcp_send_record(TDSSOCKET *tds, TDSBCPINFO *bcpinfo, tds_bcp_get_col_data ge
 						memcpy(record, timestamp, 8); record += 8;
 						new_record_size += 25;
 					}
-					varint_4 = bindcol->bcp_column_data->datalen;
-#if WORDS_BIGENDIAN
-					tds_swap_datatype(SYBINT4, (unsigned char *)&varint_4);
-#endif
-					memcpy(record, &varint_4, 4); record += 4; new_record_size +=4;
+					TDS_PUT_UA4LE(record, bindcol->bcp_column_data->datalen);
+					record += 4; new_record_size +=4;
 					break;
 				case 2:
-					varint_2 = bindcol->bcp_column_data->datalen;
-#if WORDS_BIGENDIAN
-					tds_swap_datatype(SYBINT2, (unsigned char *)&varint_2);
-#endif
-					memcpy(record, &varint_2, 2); record += 2; new_record_size +=2;
+					TDS_PUT_UA2LE(record, bindcol->bcp_column_data->datalen);
+					record += 2; new_record_size +=2;
 					break;
 				case 1:
 					varint_1 = bindcol->bcp_column_data->datalen;
@@ -702,19 +795,18 @@ tds_bcp_add_variable_columns(TDSBCPINFO *bcpinfo, tds_bcp_get_col_data get_col_d
  * \return TDS_SUCCEED or TDS_FAIL.
  */
 static int
-tds_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
+tds7_bcp_send_colmetadata(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 {
-	const static unsigned char colmetadata_token = 0x81;
 	TDSCOLUMN *bcpcol;
 	int i, num_cols;
 
-	tdsdump_log(TDS_DBG_FUNC, "tds_bcp_send_colmetadata(%p, %p)\n", tds, bcpinfo);
+	tdsdump_log(TDS_DBG_FUNC, "tds7_bcp_send_colmetadata(%p, %p)\n", tds, bcpinfo);
 	assert(tds && bcpinfo);
 
 	/* 
 	 * Deep joy! For TDS 8 we have to send a colmetadata message followed by row data 
 	 */
-	tds_put_byte(tds, colmetadata_token);	/* 0x81 */
+	tds_put_byte(tds, TDS7_RESULT_TOKEN);	/* 0x81 */
 
 	num_cols = 0;
 	for (i = 0; i < bcpinfo->bindinfo->num_cols; i++) {
@@ -812,6 +904,10 @@ tds_bcp_start(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 
 	tds_submit_query(tds, bcpinfo->insert_stmt);
 
+	/*
+	 * In TDS 5 we get the column information as a result set from the "insert bulk" command.
+	 * We're going to ignore it.  
+	 */
 	if (tds_process_simple_query(tds) != TDS_SUCCEED)
 		return TDS_FAIL;
 
@@ -820,7 +916,7 @@ tds_bcp_start(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 	tds_set_state(tds, TDS_QUERYING);
 
 	if (IS_TDS7_PLUS(tds))
-		tds_bcp_send_colmetadata(tds, bcpinfo);
+		tds7_bcp_send_colmetadata(tds, bcpinfo);
 	
 	return TDS_SUCCEED;
 }
@@ -847,11 +943,7 @@ tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 	if (tds_bcp_start_insert_stmt(tds, bcpinfo) == TDS_FAIL)
 		return TDS_FAIL;
 
-	/*
-	 * In TDS 5 we get the column information as a result set from the "insert bulk" command.
-	 * We're going to ignore it.  
-	 */
-	if (tds_process_simple_query(tds) != TDS_SUCCEED) {
+	if (tds_bcp_start(tds, bcpinfo) != TDS_SUCCEED) {
 		/* TODO, in CTLib was _ctclient_msg(blkdesc->con, "blk_rowxfer", 2, 5, 1, 140, ""); */
 		return TDS_FAIL;
 	}
@@ -969,13 +1061,5 @@ tds_bcp_start_copy_in(TDSSOCKET *tds, TDSBCPINFO *bcpinfo)
 		}
 	}
 
-	/* set packet type to send bulk data */
-	tds->out_flag = TDS_BULK;
-	/* FIXME find a better way, some other thread could change state here */
-	tds_set_state(tds, TDS_QUERYING);
-
-	if (IS_TDS7_PLUS(tds))
-		tds_bcp_send_colmetadata(tds, bcpinfo);
-
 	return TDS_SUCCEED;
 }

